package com.example.onlinejudge.controller;

import cn.dev33.satoken.stp.StpUtil;
import cn.dev33.satoken.util.SaResult;
import cn.hutool.core.util.StrUtil;
import com.alibaba.druid.util.StringUtils;
import com.example.onlinejudge.model.dto.user.UserLoginRequest;
import com.example.onlinejudge.model.entity.result.Result;
import com.example.onlinejudge.model.entity.result.ResultCode;
import com.example.onlinejudge.service.UserService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;


@Controller
@RequestMapping("/api/user")
public class UserController {

    @Resource
    private UserService userService;

    @ApiOperation(value = "用户登录")
    @PostMapping("/login")
    @ResponseBody
    public Result login(@RequestBody UserLoginRequest userLoginRequest) {
        if(userLoginRequest == null) {
            return Result.error(ResultCode.PARAM_IS_INVALID.getCode(),ResultCode.PARAM_IS_INVALID.getMessage());
        }
        String username = userLoginRequest.getUserName();
        String password = userLoginRequest.getPassword();
        if(StrUtil.isBlank(username) || StrUtil.isBlank(password)) {
            return Result.error(ResultCode.PARAM_IS_BLANK.getCode(),ResultCode.PARAM_IS_BLANK.getMessage());
        }
        return userService.login(username, password);
    }

    @ApiOperation(value = "判断用户是否登录")
    @GetMapping("/isLogin")
    @ResponseBody
    public String isLogin() {
        return "当前会话登录了";
    }

    @ApiOperation(value = "用户登出")
    @GetMapping("/logout")
    @ResponseBody
    public Result logout() {
        StpUtil.logout();
        return Result.success();
    }

}
