package com.example.onlinejudge.model.VO;

import cn.hutool.json.JSONUtil;
import com.example.onlinejudge.model.dto.questionSubmit.JudgeInfo;
import com.example.onlinejudge.model.entity.QuestionSubmit;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiOperation;
import lombok.Data;
import org.springframework.beans.BeanUtils;

import java.io.Serializable;
import java.util.Date;

@Data
@ApiModel("提交题目信息")
public class QuestionSubmitVO implements Serializable {

    @ApiModelProperty("提交题目ID")
    private Long id;

    @ApiModelProperty("编程语言")
    private String language;

    @ApiModelProperty("用户代码")
    private String code;

    @ApiModelProperty("判题信息")
    private JudgeInfo judgeInfo;

    @ApiModelProperty("判题状态（0 - 待判题、1 - 判题中、2 - 成功、3 - 失败）")
    private Integer status;

    @ApiModelProperty("题目 id")
    private Long questionId;

    @ApiModelProperty("创建用户 id")
    private Long userId;

    @ApiModelProperty("创建时间")
    private Date createTime;

    @ApiModelProperty("更新时间")
    private Date updateTime;

    @ApiModelProperty("提交用户信息")
    private UserVO userVO;

    @ApiModelProperty("对应题目信息")
    private QuestionVO questionVO;

    /**
     * 包装类转对象
     *
     * @param questionSubmitVO
     * @return
     */
    public static QuestionSubmit voToObj(QuestionSubmitVO questionSubmitVO) {
        if (questionSubmitVO == null) {
            return null;
        }
        QuestionSubmit questionSubmit = new QuestionSubmit();
        BeanUtils.copyProperties(questionSubmitVO, questionSubmit);
        JudgeInfo judgeInfoObj = questionSubmitVO.getJudgeInfo();
        if (judgeInfoObj != null) {
            questionSubmit.setJudgeInfo(JSONUtil.toJsonStr(judgeInfoObj));
        }
        return questionSubmit;
    }

    /**
     * 对象转包装类
     *
     * @param questionSubmit
     * @return
     */
    public static QuestionSubmitVO objToVo(QuestionSubmit questionSubmit) {
        if (questionSubmit == null) {
            return null;
        }
        QuestionSubmitVO questionSubmitVO = new QuestionSubmitVO();
        BeanUtils.copyProperties(questionSubmit, questionSubmitVO);
        String judgeInfoStr = questionSubmit.getJudgeInfo();
        questionSubmitVO.setJudgeInfo(JSONUtil.toBean(judgeInfoStr, JudgeInfo.class));
        return questionSubmitVO;
    }

    private static final long serialVersionUID = 1L;
}
