package com.example.onlinejudge.model.VO;

import cn.hutool.core.bean.BeanUtil;
import com.example.onlinejudge.model.entity.User;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

@Data
@ApiModel("用户信息")
public class UserVO implements Serializable {

    @ApiModelProperty("用户ID")
    private Long id;

    @ApiModelProperty("用户名")
    private String userName;

    @ApiModelProperty("用户头像")
    private String userAvatar;

    @ApiModelProperty("用户简介")
    private String userProfile;

    @ApiModelProperty("用户角色")
    private String userRole;

    @ApiModelProperty("用户创建时间")
    private Date createTime;

    private static final long serialVersionUID = 1L;

    /** TODO: 没有对userProfile和userAvatar、createTime属性进行处理
     * User对象转UserVO包装类
     * @param user User对象
     * @return UserVo
     */
    public static UserVO objToVo(User user) {
        if (user == null)
            return null;
        UserVO userVO = new UserVO();
        userVO.setUserName(user.getUsername());
        userVO.setUserRole(user.getRole());
        userVO.setId(user.getId());
        return userVO;
    }
}
