package com.example.onlinejudge.model.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;


@ApiModel("题目提交")
@TableName(value ="question_submit")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class QuestionSubmit {

    @ApiModelProperty("提交ID")
    @TableId(type = IdType.ASSIGN_ID)
    private Long id;

    @ApiModelProperty("编程语言")
    private String language;

    @ApiModelProperty("用户代码")
    private String code;

    @ApiModelProperty("判题信息（json 对象）")
    private String judgeInfo;

    @ApiModelProperty("判题状态（0 - 待判题、1 - 判题中、2 - 成功、3 - 失败）")
    private Integer status;

    @ApiModelProperty("题目 id")
    private Long questionId;

    @ApiModelProperty("创建用户 id")
    private Long userId;

    @ApiModelProperty("创建时间")
    private Date createTime;

    @ApiModelProperty("更新时间")
    private Date updateTime;

    @ApiModelProperty("用户自测用例")
    private String userCases;

    @ApiModelProperty("用户自测用例的输出")
    private String output;

    @ApiModelProperty("判断模式 (0 - 系统用例判别 1 - 用户自测用例判别)")
    private Integer judgeMode;

    @ApiModelProperty("是否删除")
    @TableLogic
    private Integer isDelete;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

}
