package com.example.onlinejudge.model.enums;

import org.apache.commons.lang3.ObjectUtils;;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public enum QuestionSubmitLanguageEnum {

    JAVA("java","java"),
    C("c","c"),
    CPP("cpp","cpp")
    ;

    private String text;
    private String value;

    QuestionSubmitLanguageEnum(String language, String languageName) {
        this.text = language;
        this.value = languageName;
    }

    /**
     * 获取值列表
     *
     * @return
     */
    public static List<String> getValues() {
        return Arrays.stream(values()).map(item -> item.value).collect(Collectors.toList());
    }

    /**
     * 根据 value 获取枚举
     *
     * @param value
     * @return
     */
    public static QuestionSubmitLanguageEnum getEnumByValue(String value) {
        if (ObjectUtils.isEmpty(value)) {
            return null;
        }
        for (QuestionSubmitLanguageEnum anEnum : QuestionSubmitLanguageEnum.values()) {
            if (anEnum.value.equals(value)) {
                return anEnum;
            }
        }
        return null;
    }



    public String getText() {
        return text;
    }

    public String getValue() {
        return value;
    }
}
