package com.example.onlinejudge.service;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.example.onlinejudge.model.VO.QuestionSubmitVO;
import com.example.onlinejudge.model.dto.questionSubmit.QuestionSubmitAddRequest;
import com.example.onlinejudge.model.dto.questionSubmit.QuestionSubmitQueryRequest;
import com.example.onlinejudge.model.entity.QuestionSubmit;
import com.example.onlinejudge.model.entity.User;

public interface QuestionSubmitService extends IService<QuestionSubmit> {

    /**
     * 题目提交
     *
     * @param questionSubmitAddRequest 题目提交信息
     * @param loginUserId
     * @return
     */
    long doQuestionSubmit(QuestionSubmitAddRequest questionSubmitAddRequest, Long loginUserId);

    /**
     * 获取查询条件
     *
     * @param questionSubmitQueryRequest
     * @return
     */
    QueryWrapper<QuestionSubmit> getQueryWrapper(QuestionSubmitQueryRequest questionSubmitQueryRequest);

    /**
     * 获取题目封装
     *
     * @param questionSubmit
     * @param loginUserId
     * @return
     */
    QuestionSubmitVO getQuestionSubmitVO(QuestionSubmit questionSubmit, Long loginUserId);

    /**
     * 分页获取题目封装
     *
     * @param questionSubmitPage
     * @param loginUserId
     * @return
     */
    Page<QuestionSubmitVO> getQuestionSubmitVOPage(Page<QuestionSubmit> questionSubmitPage, Long loginUserId);
}